/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 */

 /* (C) Marcin Kwadrans <quar@vitea.pl> */

#include "include/support.h"
#include "include/command.h"
#include "include/message.h"

class LWCommandGetPositionY: public LWCommand {

LWValue *execute1 (LWContext *context, guint argc, LWValue *args[])
{
	g_return_val_if_fail (argc == 0, NULL);
	
	LWPiece *piece = context->wizard->getPiece();
	LWRow *row = piece->getRow();
	LWBoard *board = row->getBoard();

	gint n = board->getRowIndex (row)+1;

	return new LWValue (n);
}

const gchar *getName ()
{
	return "getpositiony";
}	

gchar *getHint ()
{
	return _("Get vertical position");
}

guint getPriority ()
{
	return 15;
}

gboolean hasReturn()
{
	return TRUE;
}

void checkArgc (guint n)
{
	if (n != 0) 
		throw new LWMessage (LW_ERROR_WrongNumberOfArguments);
}	

};

LWSymbol *new_LWCommandGetPositionY()
{
	return new LWCommandGetPositionY();
}
