/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 */

 /* (C) Marcin Kwadrans <quar@vitea.pl> */

#include "include/support.h"
#include "include/command.h"
#include "include/message.h"

class LWCommandGo: public LWCommand {

LWValue *execute1 (LWContext *context, guint argc, LWValue *args[])
{
	g_return_val_if_fail (argc == 0 || argc == 1, NULL);
	
	if (argc == 1) {
		context->wizard->go (args[0]->toInt(), TRUE);
	} else
		context->wizard->go (1, TRUE);

	return NULL;
}	

const gchar *getName (void) 
{
	return "go";
}	

gchar *getHint ()
{
	return _("Go one or more steps");
}

void checkArgc (guint n)
{
	if (n > 1) 
		throw new LWMessage (LW_ERROR_WrongNumberOfArguments);
}

};

LWSymbol *new_LWCommandGo()
{
	return new LWCommandGo();
}
